;*******************************************************************************
;*
;*      Titel:  Unterprogramm zur Umcodieren
;*              (SR_RECODE.asm)
;*
;*      Datum:  13/02/12        Version:        0.2 (24/4/12)
;*      Autor:  WEIGU
;*
;*      Informationen zur Beschaltung:
;*      Prozessor:      ATmega32A/644p/32u4	Quarzfrequenz:  
;*      Eingaenge:
;*      Ausgaenge:
;*
;*      Informationen zur Funktionsweise:
;*      
;*      
;*      
;*      Unterprogramme:
;*      RTCSND:	Daten zum DS1307 senden (8 Datenbyte)
;*
;*      
;*      Copyright (c) 2012   Guy WEILER         weigu[at]weigu[dot]lu
;*
;*      Hiermit wird unentgeltlich, jeder Person, die eine Kopie der Software
;*      und der zugehoerigen Dokumentationen (die "Software") erhaelt, die
;*      Erlaubnis erteilt, uneingeschraenkt zu benutzen, inklusive und ohne
;*      Ausnahme, dem Recht, sie zu verwenden, kopieren, aendern, fusionieren,
;*      verlegen, verbreiten, unterlizenzieren und/oder zu verkaufen, und
;*      Personen, die diese Software erhalten, diese Rechte zu geben, unter den
;*      folgenden Bedingungen:
;*
;*      ;Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in alle
;*      ;Kopien oder Teilkopien der Software beizulegen.
;*      ;
;*      ;DIE SOFTWARE WIRD OHNE JEDE AUSDRUECKLICHE ODER IMPLIZIERTE GARANTIE
;*      ;BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FUER DEN
;*      ;VORGESEHENEN ODER EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTS-
;*      ;VERLETZUNG, JEDOCH NICHT DARAUF BESCHRAENKT. IN KEINEM FALL SIND DIE
;*      ;AUTOREN ODER COPYRIGHTINHABER FUER JEGLICHEN SCHADEN ODER SONSTIGE
;*      ;ANSPRUECHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFUELLUNG EINES
;*      ;VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE
;*      ;ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.
;*
;*******************************************************************************
;Damit der Code im Flash gering bleibt werden ausschliesslich die benutzten
;Unterprogramme freigeschaltet (Flag = 1)
.EQU    Flag_BCD2A2 = 0		;BCD nach ASCII 2 Byte
.EQU    Flag_DEC2A2 = 0		;Dezimal bis 99 nach ASCII 2 Byte
.EQU    Flag_DEC2A5 = 1		;Dezimal bis 65536 nach ASCII 5 Byte
.EQU    Flag_ASC2D2 = 1		;ASCII 2 Byte nach Dezimal 
.EQU    Flag_ASC2D4 = 1		;ASCII 4 Byte nach Dezimal
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;       Reservierungen und Zuweisungen
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.DSEG
TD2A5:	.BYTE	5		;Tabelle fuer ASCII-Zeichen DEC2A5
.CSEG
;-------------------------------------------------------------------------------
;	BCD nach ASCII (BCD in r24, ASCII in r25:r24)
;-------------------------------------------------------------------------------
.IF Flag_BCD2A2 == 1
BCD2A2:
	push	r16
	push	r17	
	ldi	r16,0x30	
	mov	r17,r24
	andi	r24,0xF0
	swap	r24	
	add	r24,r16	
	mov	r25,r24
	mov	r24,r17
	andi	r24,0x0F
	add	r24,r16
	pop	r17
	pop	r16
	ret
.ENDIF	

;-------------------------------------------------------------------------------
;	Dezimal  bis 99 nach ASCII (Dezimal in r24, ASCII in r25:r24)
;-------------------------------------------------------------------------------
.IF Flag_DEC2A2 == 1
DEC2A2:	push	r16	
	mov	r0,r24
	clr	r1
	ldi	r16,10	
	mov	r2,r16	
	rcall	DIV21
	mov	r24,r1
	mov	r25,r0
	ldi	r16,0x30	
	add	r24,r16	
	add	r25,r16	
	pop	r16
	ret
.ENDIF	

;-------------------------------------------------------------------------------
;	Dezimal  bis 65535 nach ASCII 
;	(Dezimal in r25:r24, ASCII in SRAM-Tabelle TD2A5)
;-------------------------------------------------------------------------------
.IF Flag_DEC2A5 == 1
DEC2A5:	push	r16	
	push	r17
	push	r18
	ldi	r18,0x30
	mov	r0,r24
	mov	r1,r25
	clr	r2
	ldi	r16,LOW(10000)
	ldi	r17,HIGH(10000)
	mov	r3,r16
	mov	r4,r17
	rcall	DIV32
	add	r0,r18
	sts	TD2A5+0,r0
	mov	r0,r1
	mov	r1,r2
	clr	r2
	ldi	r16,LOW(1000)
	ldi	r17,HIGH(1000)
	mov	r3,r16
	mov	r4,r17
	rcall	DIV32
	add	r0,r18
	sts	TD2A5+1,r0
	mov	r0,r1
	mov	r1,r2
	ldi	r16,100
	mov	r2,r16
	rcall	DIV21
	add	r0,r18
	sts	TD2A5+2,r0
	mov	r0,r1
	clr	r1
	ldi	r16,10
	mov	r2,r16
	rcall	DIV21
	add	r0,r18
	sts	TD2A5+3,r0
	add	r1,r18
	sts	TD2A5+4,r1
	pop	r18
	pop	r17
	pop	r16
	ret
.ENDIF	

;-------------------------------------------------------------------------------
;	ASCII (2 Byte) nach Dezimal (ASCII in r25:r24, Dezimal in r24 )
;-------------------------------------------------------------------------------
.IF Flag_ASC2D2 == 1
ASC2D2:	push	r16	
	ldi	r16,10	
	subi	r25,0x30	
	subi	r24,0x30	
	mul	r25,r16
	add	r24,r0
	pop	r16
	ret
.ENDIF	
;-------------------------------------------------------------------------------
;	ASCII (4 Byte) nach Dezimal	(ASCII in Tabelle Tabellenzeiger X
;					Dezimal in r25:r24)
;	Kann bei durchgehenden Tabellen mehrfach hintereinander verwendet werden
;	ohne Neuinitialisierung des Tabellenzeigers!
;-------------------------------------------------------------------------------
.IF Flag_ASC2D4 == 1
ASC2D4:	push	r16
	push	r17

	ld 	r16,X+		;oberste Stelle mit 1000 multiplizieren
	subi 	r16,0x30
	ldi 	r17,10
	mul	r16,r17	
	mov	r16,r0
	ldi 	r17,100
	mul	r16,r17
	mov	r24,r0
	mov	r25,r1
	ld 	r16,X+		;*100
	subi 	r16,0x30
	ldi 	r17,100
	mul	r16,r17		
	add	r24,r0
	adc	r25,r1
	ld 	r16,X+		;*10
	subi 	r16,0x30
	ldi 	r17,10
	mul	r16,r17		
	add	r24,r0
	adc	r25,r1
	ld 	r16,X+		;addieren	
	subi 	r16,0x30
	add	r24,r16
	adc	r25,Zero

	pop	r17
	pop	r16
	ret
.ENDIF	

